<?php
include_once ROOTPATH."/../expressoMail1_2/inc/class.imap_functions.inc.php";

class Helpers {    

/**
 * LABEL
 */ 
	//labeled:after.find
	public function deepnessLabeleds( &$uri , &$result , &$criteria , $original ){                

		if(isset($original['criteria']['deepness']))
		{
			foreach ($result as $i => $v)
			{
				if(isset($v['labelId']))
				{
					$labels = Controller::find( array( 'concept' => 'label' ) , false, array( 'filter' => array('=', 'id'  ,  $v['labelId']) ));     
					$result[$i]['label'] = $labels[0];
				}              

			}
		}

		return $result;
	}
	
	/**
	 * Método a ser chamado na exclusão de um label, procedendo com a
	 * desvinculação deste label com todas as mensagens a que estava vinculado
	 */
	//label:before.delete
	public function clearAllLabeledsOfLabel( &$uri , &$result , &$criteria , $original ){
		
		$labeleds = Controller::find( array( 'concept' => 'labeled' ) , false, array( 'filter' => array('=', 'labelId'  ,  $uri['id']) ));
		if (empty($labeleds))
			return;
		
		$labeledsIds = array();
		foreach ($labeleds as $e) {
				$labeledsIds[] = $e['id'];
		}
		
		Controller::delete( array( 'concept' => 'labeled' ), false, array( 'filter' => array( 'IN', 'id', $labeledsIds )) );

		//return $result;
	}
	/**
	 * Método a ser chamado ao listar os labeleds, uma vez que as funções de IMAP do PHP não são capazes de 
	 * obter a lista de todos os labels e nem são capazes de obter os labels de uma dada mensagem
	 */
	//labeled:before.find
	public function makeLabelListFilter( &$uri , &$result , &$criteria , $original ){

		if (!isset($criteria['filter']) || !self::in_arrayr('labelId', $criteria['filter'])) {
			$labels = Controller::find( array( 'concept' => 'label' ) );

			$list = array();
			foreach ($labels as $label)
				$list[] = $label['id'];
				
			$filter = array( 'IN' , 'labelId' , $list );
			
			if (isset($criteria['filter']) && $criteria['filter']!=NULL && count($criteria['filter']) != 0)
				$criteria['filter'] = array( 'AND', $criteria['filter'], $filter );
			else
				$criteria['filter'] =  $filter;
		}
	}
		
	public static function in_arrayr($needle, $haystack) {
		//if(!is_array($haystack)) return false;
		
		foreach ($haystack as $v) {
				if ($needle == $v) return true;
				elseif (is_array($v)) return self::in_arrayr($needle, $v);
		}
		return false;
	} 
	
/**
 * FOLLOWUPFLAG
 */ 
 
	//followupflag:before.find 
	public function addDefaultElementsFilter (&$uri , &$params , &$criteria , $original ){ 
		//if (!self::in_arrayr('id', $criteria['filter'])) { 
			$defaultsFilter = array( 'IN' , 'id' , array('1','2','3','4','5','6') ); 

			if (isset($criteria['filter']) && $criteria['filter']!=NULL && count($criteria['filter']) != 0) 
				$criteria['filter'] = array( 'OR', $criteria['filter'], $defaultsFilter ); 
			else 
				$criteria['filter'] =  $defaultsFilter; 
		//} 
	}

	//Remove as dependencias de uma followupflag 
	public function clearAllFlaggedOfFollowupflag( &$uri , &$result , &$criteria , $original ){
		//remove apenas se vier o id da Followupflag
		if(isset($uri['id'])) {
			Controller::deleteALL(array('concept' => 'followupflagged'), null , array('filter' => array('=' , 'followupflagId' , $uri['id'])));
		
		}
	}

	//followupflagged:PostgreSQL.before.delete
	public function doImapDelete( &$uri , &$params , &$criteria , $original ) {
	
		$imap_uri = $uri;
		$imap_uri['service'] = 'Imap';
		list($messageId, $uri['id']) = explode('#', $uri['id']);

		$result = Controller::delete($imap_uri, $params, $imap_criteria);

		if (!$result)
			return false;
	}
		
	//followupflagged:PostgreSQL.before.create
	public function doImapCreate( &$uri , &$params , &$criteria , $original ) {	
		
		$imap_uri = $uri;
		$imap_uri['service'] = 'Imap';

		$params = Controller::create($imap_uri, $params);
		
		if (!$params)
			return false;	
	}
	
	//followupflagged:PostgreSQL.after.read
	public function doImapRead( &$uri , &$result , &$criteria , $original ) {

		if ($result) {
			$imap_result = Controller::read(
				array('concept' => 'followupflagged', 'service' => 'Imap'), 
				false, 
				array('filter' => array('=', 'messageId', $result['messageId']))
			);
		}

		/**
		 * Faz a consistência do banco com o imap
		 */
		if (!$imap_result) {
			$r = Controller::deleteALL(array('concept' => 'followupflagged'), null , $criteria);
			return false;
		}
		
		/**
		 * Faz a consistência do banco com o imap
		 */
		if ($imap_result['messageId'] !== $imap_result['messageId']) {
			$n = $imap_result;
			$n['followupflagId']  = 1;
			$n['backgroundColor'] = '#FF2016';
			$n['id'] = Controller::create(array('concept' => 'followupflagged'), $n);
			$result = $imap_result + $n;
		}
		
		$result = $result + $imap_result;
		
		return $result;
	}
	
	
	/**
	 * Método a ser chamado ao listar os sinalizadores, uma vez que as funções de IMAP do PHP não são capazes de 
	 * obter a lista de todos os sinalizadores e nem são capazes de obter os sinalizadores de uma dada mensagem
	 */
	//followupflagged:PostgreSQL.after.find
	public function doImapFind( &$uri , &$result , &$criteria , $original ){

		$imap_uri = $uri;
		$imap_uri['service'] = 'Imap';
		$imap_result = Controller::find($imap_uri, false, $original['criteria']);

		/**
		 * Mescla os dados vindos do PostgreSQL com os dados vindos do Imap
		 */
		$merge_result = array ();
		foreach ($imap_result as $j => $ir) {
		
			foreach($result as $k => $r) {
				if ($r['messageId'] == $ir['messageId']) {
					$merge_result[] = $r + $ir;
					unset($result[$k]);
					break;
				}
			}
			
			unset($imap_result[$j]);
		}
		
		/**
		 * Faz a consistência do banco com o imap
		 */
		if ($result) {
			$idList = array();
			foreach ($result as $ir ) {
				$idList = $ir['messageId'];
			}
			$filter = array('IN','messageId',$idList);
			Controller::delete(array('concept' => 'followupflagged'), null , array('filter' => $filter));
		}
		
		/**
		 * Faz a consistência do banco com o imap
		 */
		if ($imap_result) {
			foreach ($imap_result as $ir ) {
				$n = $ir;
				$n['followupflagId']  = 1;
				$n['backgroundColor'] = '#FF2016';
				$n['id'] = Controller::create(array('concept' => 'followupflagged'), $n);
				$merge_result[] = $ir + $n;
			}
		}
			
		return $merge_result;
	}

	//followupflagged:PostgreSQL.before.find
	public function reFilterFind (&$uri , &$params , &$criteria , $original ){
		/**
		 * Se p filtor incluir atributos da mensagem que o banco de dados não conhece,  
		 * deve-se obter os messageId dos itens do resultado e passálos num novo filtro
		 * que o banco conheça
		 */
		if (self::in_arrayr('messageNumber', $criteria) || self::in_arrayr('folderName', $criteria)) {
			$result = Controller::find(array('concept' => 'message'), array('messageId'), array('filter' => $criteria['filter']));
			$idList = array();
			foreach ($result as $message)
				$idList[] = $message['messageId'];
				
			$filter = array( 'IN' , 'messageId' , $idList );

			$criteria['filter'] =  $filter;
		}	
	}	

	//label:before.create
	public function validateLabel(&$uri , &$params , &$criteria , $original){

		if( !!Controller::find( array('concept' => 'label'), false, array('filter' => array('i=', 'name', $params['name'])) ) )
		{
		    throw new Exception('Já existe um marcador com esse nome.');
		}

		$used = Controller::service('PostgreSQL')->execSql( 'SELECT count(slot) as used from expressomail_label where user_id = '.Config::me('uidNumber'), true );

		if( $used['used'] === '0' )
		{
		    $params['id'] = '1';
		    return;
		}

		$slot = Controller::service('PostgreSQL')->execSql( 'SELECT label.slot + 1 as id FROM expressomail_label as label, phpgw_config as config WHERE label.user_id = '.Config::me('uidNumber').' AND config.config_name = \'expressoMail_limit_labels\' AND label.slot <= config.config_value::integer AND ( SELECT count(slot) FROM expressomail_label WHERE slot = label.slot + 1 AND user_id = '.Config::me('uidNumber').' ) = 0 limit 1', true );

		if( empty( $slot ) )
		{
		    throw new Exception('Nenhum slot disponivel.');
		}

		$params['id'] = $slot['id'];
	}
}

?>
